--------------------------MODULE Interruttore------------------------------------------------
EXTENDS Naturals
VARIABLES stato,cond1,cond2

---------------------------------------------------------------------------------------------
(* INIZIALIZZAZIONE *)

Inv == /\stato \in {0,1}
	   /\cond1 \in {0,1}
	   /\cond2 \in {0,1}
	
IInit == /\ stato=0
		 /\ cond1=0
		 /\ cond2=0
---------------------------------------------------------------------------------------------
(* AZIONI *)

LOCAL luce == /\ (cond1'= CASE (stato=0 /\ cond1=1 /\ cond2=0) -> 0 [] TRUE -> cond1)
			  /\ (cond2'= CASE (stato=0 /\ cond1=1 /\ cond2=0) -> 0 [] TRUE -> cond2)
			  
LOCAL buio == /\ (cond1'= CASE (stato=1 /\ cond1=0 /\ cond2=0) -> 1 [] TRUE -> cond1)
			  /\ (cond2'= CASE (stato=1 /\ cond1=0 /\ cond2=0) -> 0 [] TRUE -> cond2)
---------------------------------------------------------------------------------------------
(* EVENTI *)

alza == (stato'=CASE (stato=0 /\ cond1=1 /\ cond2=0) -> 1 [] TRUE -> stato)
		/\ luce

abbassa == (stato'=CASE (stato=1 /\ cond1=0 /\ cond2=0) -> 0 [] TRUE -> stato) 
			/\ buio

INext == \/ alza \/ abbassa
---------------------------------------------------------------------------------------------
ISpec == IInit /\ [][INext]_{stato, cond1, cond2}

THEOREM ISpec => []Inv

=============================================================================================