-----------------------------------------MODULE Massimo--------------------------------------
EXTENDS Reals, Sequences

VARIABLES i, stato, result(*, vett*)

CONSTANT MIN,N
---------------------------------------------------------------------------------------------
(* INIZIALIZZAZIONE *)

 vett == << 3,6,15>>
 
MInv == /\ i \in Nat 
		/\ stato \in {1,2,3,4,5,6,7}
		/\ N \in Nat /\ N>0
		/\ i<=N
				
MInit == /\ result=MIN
		 /\ i=1
		 /\ stato=3

---------------------------------------------------------------------------------------------
(* TRANSIZIONI DEL GRAFO *)

LOCAL testWhile == /\ (stato'= CASE (stato=3 /\ (i \leq N))->4 [] (stato=3 /\ (i > N))->7[] TRUE ->stato)
				   /\ result'=result
				   /\ i'=i

LOCAL testIf == /\(stato'= (CASE (stato=4 /\ vett[i]>result)->5[] (stato=4 /\ vett[i]>result)->6 []TRUE ->stato))
			/\ result'=result
			/\ i'=i

LOCAL assegnazione == /\ (stato'=(CASE stato=5 ->6 [] TRUE-> stato))
					  /\ (result'= (CASE stato=5-> vett[i][] TRUE->result))
					  /\ i'=i

LOCAL incI == /\ (stato'= CASE (stato=6)->3 [] TRUE -> stato)
			  /\ (i'=CASE (stato=6) ->i+1 [] TRUE ->i)
			  /\ result'=result
					  
LOCAL return == /\ (stato'= CASE (stato=7 \/ stato=8)->8 [] TRUE -> stato)
				/\ result'=result
				/\ i'=i
				
Next == testWhile \/ testIf \/ assegnazione \/ incI \/return
--------------------------------------------------------------------------------------------
Mspec == MInit /\ [][Next]_{stato,i,result} /\ <>[](stato=8)

Terminata == <>[](stato=8)
Pre == \A x \in {1,2,3}: vett[x]>0
Occorrenza == (\E x \in {1,2,3}: (vett[x]>0 /\ vett[x]=result))
Maggiore == \A x \in {1,2,3}: result >= vett[x]
Post == Occorrenza /\ Maggiore
Term == (Pre => <> Terminata )
CParz == (Pre => [](Terminata =>Post))
CTot == (Pre => ((<> Terminata) /\ ([]Terminata =>[]Post)))
Prova == Pre => Occorrenza
==============================================================================================